<?php
/*
 ex: set tabstop=4 shiftwidth=4 autoindent:
 +-------------------------------------------------------------------------+
 | Copyright (C) 2009 The Cacti Group                                      |
 |                                                                         |
 | This program is free software; you can redistribute it and/or           |
 | modify it under the terms of the GNU General Public License             |
 | as published by the Free Software Foundation; either version 2          |
 | of the License, or (at your option) any later version.                  |
 |                                                                         |
 | This program is distributed in the hope that it will be useful,         |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of          |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           |
 | GNU General Public License for more details.                            |
 +-------------------------------------------------------------------------+
 | Cacti: The Complete RRDTool-based Graphing Solution                     |
 +-------------------------------------------------------------------------+
 | This code is designed, written, and maintained by the Cacti Group. See  |
 | about.php and/or the AUTHORS file for specific developer information.   |
 +-------------------------------------------------------------------------+
 | http://www.cacti.net/                                                   |
 +-------------------------------------------------------------------------+
*/

function gpsmap_draw_navigation_text ($nav) {
   $nav['gpsmap.php:'] = array('title' => 'GPS Map', 'mapping' => 'index.php:', 'url' => 'gpsmap.php', 'level' => '1');
   $nav['gpstemplates.php:'] = array('title' => 'GPS Templates', 'mapping' => 'index.php:', 'url' => 'gpstemplates.php', 'level' => '1');
   $nav['gpstemplates.php:save'] = array('title' => 'GPS  Templates', 'mapping' => 'index.php:', 'url' => 'gpstemplates.php', 'level' => '1');
   $nav['gpstemplates.php:add'] = array('title' => 'GPS  Templates', 'mapping' => 'index.php:', 'url' => 'gpstemplates.php', 'level' => '1');
   $nav['gpstemplates.php:actions'] = array('title' => 'GPS  Templates', 'mapping' => 'index.php:', 'url' => 'gpstemplates.php', 'level' => '1');

   $nav['gpstemplates_add.php:'] = array('title' => 'Create Template', 'mapping' => 'index.php:', 'url' => 'gpstemplates_add.php', 'level' => '1');
   return $nav;
}

function gpsmap_config_arrays () {
    global $menu;
   $menu['Templates']['plugins/gpsmap/gpstemplates.php'] = 'Map Templates';
}

function gpsmap_api_device_save ($save) {

    if (isset($_POST['GPScoverage']))
	$save['GPScoverage'] = "on";        
    else
 	$save['GPScoverage'] = "off";        

    if (isset($_POST['latitude']))
        $save['latitude'] = form_input_validate($_POST['latitude'], 'latitude', '', true, 3);
    else
        $save['latitude'] = form_input_validate('', 'latitude', '', true, 3);
	
    if (isset($_POST['longitude']))
        $save['longitude'] = form_input_validate($_POST['longitude'], 'longitude', '', true, 3);
    else
        $save['longitude'] = form_input_validate('', 'longitude', '', true, 3);
	    
    return $save;
}

function gpsmap_config_settings () { 
//this puts the following form elements on the Settings->GPS Map tab in cacti
    global $tabs, $settings;
    global $config;

    $tabs["gpsmap"] = "GPS Map";
                               
    $settings["gpsmap"] = array(
        "gpsmap_header" => array(
            "friendly_name" => "GPS Map",
            "method" => "spacer",
            ),
        "gpsmap_apikey" => array(
            "friendly_name" => "Google API Key",
            "description" => "Requires a google API Key, get one <a href=\"http://code.google.com/apis/maps/\">HERE</a>",
            "method" => "textbox",
            "max_length" => 100,
            ),
	 "gpsmap_latutude" => array(
            "friendly_name" => "Initial Latitude",
            "description" => "Defines the centering of the map",
            "method" => "textbox",
            "max_length" => 12,
            ),
	  "gpsmap_longitude" => array(
            "friendly_name" => "Initial Longitude",
            "description" => "Defines the centering of the map",
            "method" => "textbox",
            "max_length" => 12,
            ),
	  "gpsmap_zoom" => array(
            "friendly_name" => "Initial elevation",
            "description" => "Defines the elevation of the map from 0 - 12",
            "method" => "textbox",
	     "default" => "12",
            "max_length" => 2,
            ),
	   "gpsmap_towerspacer" => array(
            "friendly_name" => "Display Settings",
            "method" => "spacer",
            ),
	 "gpsmap_multipleoverlay" => array(
            "friendly_name" => "Multiple AP overlay",
            "description" => "This allows for APs on the same subnet to display overlay, good only if you have differnet GPS coordinates for the APs",
            "method" => "checkbox",
            ),
	"gpsmap_enableall" => array(
            "friendly_name" => "Allow display of disabled hosts",
            "description" => "",
            "method" => "checkbox",
	     "default" => "off",
            ),
	 "gpsmap_toweronly" => array(
            "friendly_name" => "Access Point Only",
            "description" => "Displays only the APs, can still perform coverage.",
            "method" => "checkbox",
            ),
	"gpsmap_towerhostid" => array(
		"friendly_name" => "Select AP",
		"description" => "Select the template to be used as an access point.",
		"method" => "drop_sql",
		"sql" => "SELECT id,name AS name FROM host_template ORDER BY id",
		"default" => "1",
	    ),
	"gpsmap_overlayspacer" => array(
            "friendly_name" => "Overlay Settings",
            "method" => "spacer",
            ),
//	"gpsmap_displayweather" => array(
//          "friendly_name" => "Display Weather",
//          "description" => "Displays current weather from NOAA. This is still testing",
//          "method" => "checkbox",
//	    "default" => "off",
//          ),
	"gpsmap_fillcolor" => array(
            "friendly_name" => "Fill Color",
            "description" => "The overlay circle fill color as FFFFFF",
            "method" => "textbox",
	    "default" => "0055ff",
            "max_length" => 7,
            ),
	  "gpsmap_licolor" => array(
            "friendly_name" => "Ring Color",
            "description" => "Defines the outer rim color as FFFFFF",
            "method" => "textbox",
	    "default" => "0055ff",
            "max_length" => 7,
            ),
	  "gpsmap_liwidth" => array(
            "friendly_name" => "Ring Width",
            "description" => "Outter Ring width",
            "method" => "textbox",
	    "default" => "2",
            "max_length" => 7,
            ),	  
	"gpsmap_fillopa" => array(
            "friendly_name" => "Fill Opacity",
            "description" => "Defines the fill opacity between 0 and 1",
            "method" => "textbox",
	    "default" => ".2",
            "max_length" => 2,
            ),
	"gpsmap_liopa" => array(
            "friendly_name" => "Ring Opacity",
            "description" => "Defines the ring opacity between 0 and 1",
            "method" => "textbox",
	    "default" => ".8",
            "max_length" => 2,
            ),                                           
	"gpsmap_circlequality" => array(
            "friendly_name" => "Quality",
            "description" => "number of divisions in circle (preferably >15) greater numbers can slow down browser performace.",
            "method" => "textbox",
	    "default" => "10",
            "max_length" => 3,
            ),
         "gpsmap_outputheader" => array(
            "friendly_name" => "File Output",
            "method" => "spacer",
            ),
         "gpsmap_kmlexport" => array(
            "friendly_name" => "KML Creation",
            "description" => "Enable KML creation when when viewing GPS map, creates KML of currently viewed map.",
            "method" => "checkbox",
            ),
    );

}

